#include "thesupportmodule.h"

#include <limits.h>
#include <stdlib.h>
#include <errno.h>


long thesupportmodule_set_trace_level(long tlevel)
{
    static long trace_level = 0L;
    long olevel = trace_level;

    trace_level = (tlevel >= 0L) ? tlevel : olevel;
    return olevel;
}



long thesupportmodule_set_trace_level_from_env(const char * envvar, long default_value)
{
    char *end;
    const char *str;
    long sl;

    if(!getenv(envvar))
        return thesupportmodule_set_trace_level(default_value);

    str = getenv(envvar);
    sl = strtol(str, &end, 10);

    if(end == str)
    {
        /* no int value */
        return thesupportmodule_set_trace_level(default_value);
    }

    if ((LONG_MIN == sl || LONG_MAX == sl) && ERANGE == errno) 
    {
        /* over/under flow */
        sl = (sl == LONG_MIN) ? LONG_MIN: LONG_MAX;
    }

    return thesupportmodule_set_trace_level(sl);
}

