#pragma once


/* TRACING/DEBUGGING NEW INFRASTRUCTURE: 
        0  totally silent (default)
        10 just info messages, 
        20 info + debug messages, 
        30 info + debug + trace messages
*/

/* this is the swiss army's knife of debugging */
long thesupportmodule_set_trace_level(long tlevel); /* don't use this fucntion directly, use the TRACE, DEBUG, INFO macros instead */
long thesupportmodule_set_trace_level_from_env(const char * envvar, long default_value);

#define TRACE(...) if( thesupportmodule_set_trace_level(-1L) >=30) {\
                        fprintf(stderr, "T. %s:%i:", __FILE__, __LINE__); \
                        fprintf(stderr,  __VA_ARGS__); \
                        fprintf(stderr, "\n"); }

#define DEBUG(...) if( thesupportmodule_set_trace_level(-1L) >=20) {\
                        fprintf(stderr, "D. %s:%i:", __FILE__, __LINE__); \
                        fprintf(stderr,  __VA_ARGS__); \
                        fprintf(stderr, "\n"); }

#define INFO(...) if( thesupportmodule_set_trace_level(-1L) >=10) {\
                        fprintf(stderr, "I. %s:%i:", __FILE__, __LINE__); \
                        fprintf(stderr,  __VA_ARGS__); \
                        fprintf(stderr, "\n"); }

#define STRINGIFY(x) #x
#define TOSTRING(x) STRINGIFY(x)

